
;   ************************************************************************
;   *		 ISP.INC - Windows for Workgroups 3.11 version		   *
;   ************************************************************************

;   This file presents symbolic information from the ISP.INC header that
;   Microsoft provides with the Windows 95 DDK, but adapted to match the
;   IOS implementation in Windows for Workgroups 3.11.

;   ========================================================================

ISP_CREATE_DDB		EQU	0000h
ISP_CREATE_DCB		EQU	0001h
ISP_CREATE_IOP		EQU	0002h
ISP_ALLOC_MEM		EQU	0003h

;   The following ISP function does not exist in Windows 95.  Microsoft's
;   name for it is not known.

ISP_VIRTUALIZE_IRQ	EQU	0004h

ISP_DEALLOC_MEM 	EQU	0005h		; 0004h in Windows 95

;   ISP function number 0006h is ill-defined in the jump table used by the
;   Windows for Workgroups 3.11 IOS.

ISP_INSERT_CALLDOWN	EQU	0007h		; 0005h in Windows 95
ISP_ASSOCIATE_DCB	EQU	0008h		; 0006h in Windows 95
ISP_GET_DCB		EQU	0009h		; 0007h in Windows 95

;   The following ISP function does not exist in Windows 95.  Microsoft's
;   name for it is not known.

ISP_UNVIRTUALIZE_IRQ	EQU	000Ah

ISP_GET_FIRST_NEXT_DCB	EQU	000Bh		; 0008h in Windows 95
ISP_DEALLOC_DDB 	EQU	000Ch		; 0009h in Windows 95
ISP_DESTROY_DCB 	EQU	000Dh		; 000Ah in Windows 95
ISP_QUERY_MATCHING_DCBS EQU	000Eh		; 000Bh in Windows 95

;   ========================================================================

ISP			STRUCT
  ISP_func		dw	?
  ISP_result		dw	?
ISP			ENDS

ISP_ddb_create		STRUCT
  ISP_ddb_hdr		ISP	{}
  ISP_ddb_size		dw	?
  ISP_ddb_ptr		dd	?
  ISP_ddb_flags 	db	?
ISP_ddb_create		ENDS

ISP_DDB_FLAG_NEED_PHYS_CONTIG	EQU	01h

ISP_dcb_create		STRUCT
  ISP_dcb_hdr		ISP	{}
  ISP_dcb_size		dw	?
  ISP_dcb_ptr		dd	?
ISP_dcb_create		ENDS

ISP_IOP_create		STRUCT
  ISP_i_c_hdr		ISP	{}
  ISP_IOP_size		dw	?
  ISP_delta_to_ior	dd	?
  ISP_IOP_ptr		dd	?
  ISP_i_c_flags 	db	?
ISP_IOP_create		ENDS

ISP_mem_alloc		STRUCT
  ISP_mem_a_hdr 	ISP	{}
  ISP_mem_size		dw	?
  ISP_mem_ptr		dd	?
  ISP_mem_type		dw	?
  ISP_mem_flags 	db	?
ISP_mem_alloc		ENDS

ISP_M_FL_INTERRUPT_TIME 	EQU	01h
ISP_M_FL_MUST_SUCCEED		EQU	02h
ISP_M_FL_EXTERNAL_IOP		EQU	04h

;   Microsoft's names for the following structure and its fields are not
;   known.

ISP_irq_virtualize	STRUCT
  ISP_i_v_hdr		ISP	{}
  ISP_i_v_irql		db	?
  ISP_i_v_flags 	db	?
  ISP_i_v_ref_data	dd	?
  ISP_i_v_hw_int_proc	dd	?
ISP_irq_virtualize	ENDS

ISP_mem_dealloc 	STRUCT
  ISP_mem_da_hdr	ISP	{}
  ISP_mem_ptr_da	dd	?
ISP_mem_dealloc 	ENDS

ISP_calldown_insert	STRUCT
  ISP_i_cd_hdr		ISP	{}
  ISP_i_cd_dcb		dd	?
  ISP_i_cd_req		dd	?
  ISP_i_cd_ddb		dd	?
  ISP_i_cd_expan_len	dw	?
  ISP_i_cd_flags	dd	?
  ISP_i_cd_lgn		db	?
ISP_calldown_insert	ENDS

ISP_dcb_associate	STRUCT
  ISP_d_a_hdr		ISP	{}
  ISP_d_a_dcb		dd	?
  ISP_d_a_drive 	db	?
ISP_dcb_associate	ENDS

ISP_dcb_get		STRUCT
  ISP_g_d_hdr		ISP	{}
  ISP_g_d_dcb		dd	?
  ISP_g_d_drive 	db	?
ISP_dcb_get		ENDS

;   Microsoft's names for the following structure and its fields are not
;   known.

ISP_irq_unvirtualize	STRUCT
  ISP_i_u_hdr		ISP	{}
  ISP_i_u_irql		db	?
			db	?
  ISP_i_u_ref_data	dd	?
  ISP_i_u_hw_int_proc	dd	?
ISP_irq_unvirtualize	ENDS

ISP_GET_FRST_NXT_DCB	STRUCT
  ISP_gfnd_hdr		ISP	{}
  ISP_gfnd_dcb_offset	dd	?
  ISP_gfnd_found_dcb	dd	?
  ISP_gfnd_dcb_type	db	?
ISP_GET_FRST_NXT_DCB	ENDS

ISP_DDB_DEALLOC 	STRUCT
  ISP_ddb_d_hdr 	ISP	{}
  ISP_ddb_d_ddb 	dd	?
  ISP_ddb_d_dvt 	dd	?
ISP_DDB_DEALLOC 	ENDS

ISP_DCB_DESTROY 	STRUCT
  ISP_ddb_d_hdr 	ISP	{}	; should be ISP_dcb_d_hdr
  ISP_dcb_d_dcb 	dd	?
ISP_DCB_DESTROY 	ENDS

ISP_QUERY_MATCH 	STRUCT
  ISP_q_match_hdr	ISP	{}
  ISP_q_match_pdcb	dd	?
  ISP_q_match_drives	dd	?
ISP_QUERY_MATCH 	ENDS

;   ************************************************************************

